/*
 ATtiny13A Touch Sensor
 Version: 1.0
 Author: Alex from insideGadgets (www.insidegadgets.com)
 Created: 7/06/2018
 Last Modified: 7/06/2018
 
 TO DO: add timer to turn off after 10 mins
 
 */
 
// ATtiny13A Pin map
//                 +-\/-+
//     Reset PB5  1|o   |8  VCC       |--- 4.4nF ---|
//           PB3  2|    |7  PB2 Input ---- 4.7M ----- GND
//           PB4  3|    |6  PB1 
//           GND  4|    |5  PB0 Mosfet LED
//                 +----+

#define F_CPU 1000000

#define adcPin 1
#define LED_MOSFET PB0

#include <avr/io.h>
#include <avr/wdt.h>
#include <avr/interrupt.h>
#include <avr/sleep.h>
#include <util/delay.h>
#include "setup.c"

int main(void) {
	setup();
	
	while (1) {
		adc_read(ADC_REF_VCC, adcPin); // Ignore first reading
		int adcReading = adc_read(ADC_REF_VCC, adcPin);
		
		// Wait for high reading
		while (adcReading <= 150) {
			adcReading = adc_read(ADC_REF_VCC, adcPin);
			_delay_ms(5);
		}
		
		PORTB ^= (1<<LED_MOSFET);
		_delay_ms(20);
		
		// Wait for low reading after averaging 2 results
		int adcAverage = adc_read(ADC_REF_VCC, adcPin);
		while (adcAverage >= 20) {
			_delay_ms(50);
			adcAverage += adc_read(ADC_REF_VCC, adcPin);
			adcAverage /= 2;
		}
	}
	
	return 0;
}

EMPTY_INTERRUPT(ADC_vect);
